from kivy.uix.screenmanager import Screen

import background


class SplashScreen(Screen):
    times = [1/1.0, 1/2.0, 1/2.0, 1/2.0, 1/2.0]

    def __init__(self, app):
        Screen.__init__(self, name='splash')
        self.app = app

        self.background = background.Background(source='Images/splash.png')
        self.background.opacity = 0
        self.add_widget(self.background)

        self.state = 0
        self.timer = 0

    def on_enter(self, *args):
        self.state = 0
        self.timer = 1

    def on_size(self, *args):
        self.background.update(self.size)

    def update(self, dt):
        self.timer -= self.times[self.state] * dt

        if self.state == 1:
            if self.timer <= 0:
                self.background.opacity = 1
            else:
                self.background.opacity = 1 - self.timer

        elif self.state == 3:
            if self.timer <= 0:
                self.background.opacity = 0
            else:
                self.background.opacity = self.timer

        elif self.state == 4:
            if self.timer <= 0:
                self.app.set_screen('menu')

        if self.timer <= 0:
            self.state += 1
            if self.state >= 5:
                self.state = 0
            self.timer = 1