from kivy.uix.screenmanager import TransitionBase
from kivy.animation import AnimationTransition


class MatrixTransition(TransitionBase):
    def on_progress(self, progression):
        a = self.screen_in
        b = self.screen_out
        manager = self.manager
        x, y = manager.pos
        width, height = manager.size
        al = AnimationTransition.out_quad
        progression = al(progression)
        a.x = b.x = x
        a.y = y + height * (1 - progression)
        b.y = y - height * progression

    def on_complete(self):
        self.screen_in.pos = self.manager.pos
        self.screen_out.pos = self.manager.pos
        super(MatrixTransition, self).on_complete()
