---VERTEX SHADER-------------------------------------------------------
#ifdef GL_ES
    precision highp float;
#endif

attribute vec3  v_pos;
attribute vec3  v_normal;
attribute vec2  v_tc0;

uniform vec4 color;
uniform mat4 modelview_mat;
uniform mat4 projection_mat;

varying vec4 frag_color;
varying vec2 uv_vec;
varying vec4 normal_vec;
varying vec4 vertex_pos;

void main (void) {
    vec4 pos = modelview_mat * vec4(v_pos,1.0);
    gl_Position = projection_mat * pos;
    frag_color = color;
    uv_vec = v_tc0;
    vertex_pos = pos;
    normal_vec = vec4(v_normal, 0.0);
}


---FRAGMENT SHADER-----------------------------------------------------
#ifdef GL_ES
    precision highp float;
#endif

varying vec4 normal_vec;
varying vec4 vertex_pos;
varying vec4 frag_color;
varying vec2 uv_vec;

uniform mat4 normal_mat;
uniform sampler2D tex;
uniform float warp;

const float v = .3;

void main (void){
    float theta = dot(normal_vec, vec4(1, 1, 1, 1)) * v + (1-v);
    vec4 color;

    if (warp == 0.0f)
    {
        color = texture2D(tex, uv_vec) * frag_color;
    }
    else
    {
        color = texture2D(tex, vec2(uv_vec.x, sin(floor(uv_vec.x * 20) + warp) * warp + uv_vec.y)) * frag_color;
    }

    gl_FragColor = color * vec4(theta, theta, theta, 1.0);
}